# coding: utf-8

"""
    Skyledge API

    Sky Ledge is an operational insights platform that gives you the visibility and control you need to minimise inefficiencies, oversight, theft, and ultimately, unnecessary costs associated with your operations.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from skyledge_sdk.models.map_rule_response import MapRuleResponse
from skyledge_sdk.models.map_tooltip_response import MapTooltipResponse
from typing import Optional, Set
from typing_extensions import Self

class AssetMapViewResponse(BaseModel):
    """
    AssetMapViewResponse
    """ # noqa: E501
    tool_tip: Optional[MapTooltipResponse] = Field(default=None, alias="toolTip")
    color: Optional[StrictStr] = None
    icon: Optional[StrictStr] = None
    state: Optional[StrictStr] = None
    heading: Optional[StrictStr] = None
    rules: Optional[List[MapRuleResponse]] = None
    __properties: ClassVar[List[str]] = ["toolTip", "color", "icon", "state", "heading", "rules"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AssetMapViewResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of tool_tip
        if self.tool_tip:
            _dict['toolTip'] = self.tool_tip.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in rules (list)
        _items = []
        if self.rules:
            for _item_rules in self.rules:
                if _item_rules:
                    _items.append(_item_rules.to_dict())
            _dict['rules'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AssetMapViewResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "toolTip": MapTooltipResponse.from_dict(obj["toolTip"]) if obj.get("toolTip") is not None else None,
            "color": obj.get("color"),
            "icon": obj.get("icon"),
            "state": obj.get("state"),
            "heading": obj.get("heading"),
            "rules": [MapRuleResponse.from_dict(_item) for _item in obj["rules"]] if obj.get("rules") is not None else None
        })
        return _obj


