# coding: utf-8

"""
    Skyledge API

    Sky Ledge is an operational insights platform that gives you the visibility and control you need to minimise inefficiencies, oversight, theft, and ultimately, unnecessary costs associated with your operations.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from skyledge_sdk.models.geometry_collection_all_of_geometries import GeometryCollectionAllOfGeometries
from typing import Optional, Set
from typing_extensions import Self

class AssetRequest(BaseModel):
    """
    AssetRequest
    """ # noqa: E501
    asset_identifier: StrictStr = Field(alias="assetIdentifier")
    name: StrictStr
    location: GeometryCollectionAllOfGeometries
    description: StrictStr
    attributes: Dict[str, Any]
    metrics: Dict[str, Union[StrictFloat, StrictInt]]
    external_urls: Dict[str, StrictStr] = Field(alias="externalUrls")
    timestamp: Optional[datetime] = None
    __properties: ClassVar[List[str]] = ["assetIdentifier", "name", "location", "description", "attributes", "metrics", "externalUrls", "timestamp"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AssetRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of location
        if self.location:
            _dict['location'] = self.location.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AssetRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "assetIdentifier": obj.get("assetIdentifier"),
            "name": obj.get("name"),
            "location": GeometryCollectionAllOfGeometries.from_dict(obj["location"]) if obj.get("location") is not None else None,
            "description": obj.get("description"),
            "attributes": obj.get("attributes"),
            "metrics": obj.get("metrics"),
            "externalUrls": obj.get("externalUrls"),
            "timestamp": obj.get("timestamp")
        })
        return _obj


