# coding: utf-8

"""
    Skyledge API

    Sky Ledge is an operational insights platform that gives you the visibility and control you need to minimise inefficiencies, oversight, theft, and ultimately, unnecessary costs associated with your operations.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from skyledge_sdk.models.linked_entity import LinkedEntity
from typing import Optional, Set
from typing_extensions import Self

class AttachmentDto(BaseModel):
    """
    AttachmentDto
    """ # noqa: E501
    id: Optional[StrictStr] = None
    path: Optional[StrictStr] = None
    name: Optional[StrictStr] = None
    description: Optional[StrictStr] = None
    organization_id: Optional[StrictStr] = Field(default=None, alias="organizationId")
    owner_id: Optional[StrictStr] = Field(default=None, alias="ownerId")
    created_at: Optional[StrictStr] = Field(default=None, alias="createdAt")
    last_modified_at: Optional[StrictStr] = Field(default=None, alias="lastModifiedAt")
    attributes: Dict[str, Any]
    linked_entity: Optional[LinkedEntity] = Field(default=None, alias="linkedEntity")
    signed_url: Optional[StrictStr] = Field(default=None, alias="signedUrl")
    __properties: ClassVar[List[str]] = ["id", "path", "name", "description", "organizationId", "ownerId", "createdAt", "lastModifiedAt", "attributes", "linkedEntity", "signedUrl"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AttachmentDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of linked_entity
        if self.linked_entity:
            _dict['linkedEntity'] = self.linked_entity.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AttachmentDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "path": obj.get("path"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "organizationId": obj.get("organizationId"),
            "ownerId": obj.get("ownerId"),
            "createdAt": obj.get("createdAt"),
            "lastModifiedAt": obj.get("lastModifiedAt"),
            "attributes": obj.get("attributes"),
            "linkedEntity": LinkedEntity.from_dict(obj["linkedEntity"]) if obj.get("linkedEntity") is not None else None,
            "signedUrl": obj.get("signedUrl")
        })
        return _obj


