# coding: utf-8

"""
    Skyledge API

    Sky Ledge is an operational insights platform that gives you the visibility and control you need to minimise inefficiencies, oversight, theft, and ultimately, unnecessary costs associated with your operations.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from skyledge_sdk.models.asset_count import AssetCount
from skyledge_sdk.models.event_type_count import EventTypeCount
from skyledge_sdk.models.importance_count import ImportanceCount
from typing import Optional, Set
from typing_extensions import Self

class ControlRoomEventsSummaryResponse(BaseModel):
    """
    ControlRoomEventsSummaryResponse
    """ # noqa: E501
    importance_summary: Optional[List[ImportanceCount]] = Field(default=None, alias="importanceSummary")
    event_type_summary: Optional[List[EventTypeCount]] = Field(default=None, alias="eventTypeSummary")
    asset_summary: Optional[List[AssetCount]] = Field(default=None, alias="assetSummary")
    __properties: ClassVar[List[str]] = ["importanceSummary", "eventTypeSummary", "assetSummary"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ControlRoomEventsSummaryResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in importance_summary (list)
        _items = []
        if self.importance_summary:
            for _item_importance_summary in self.importance_summary:
                if _item_importance_summary:
                    _items.append(_item_importance_summary.to_dict())
            _dict['importanceSummary'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in event_type_summary (list)
        _items = []
        if self.event_type_summary:
            for _item_event_type_summary in self.event_type_summary:
                if _item_event_type_summary:
                    _items.append(_item_event_type_summary.to_dict())
            _dict['eventTypeSummary'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in asset_summary (list)
        _items = []
        if self.asset_summary:
            for _item_asset_summary in self.asset_summary:
                if _item_asset_summary:
                    _items.append(_item_asset_summary.to_dict())
            _dict['assetSummary'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ControlRoomEventsSummaryResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "importanceSummary": [ImportanceCount.from_dict(_item) for _item in obj["importanceSummary"]] if obj.get("importanceSummary") is not None else None,
            "eventTypeSummary": [EventTypeCount.from_dict(_item) for _item in obj["eventTypeSummary"]] if obj.get("eventTypeSummary") is not None else None,
            "assetSummary": [AssetCount.from_dict(_item) for _item in obj["assetSummary"]] if obj.get("assetSummary") is not None else None
        })
        return _obj


