# coding: utf-8

"""
    Skyledge API

    Sky Ledge is an operational insights platform that gives you the visibility and control you need to minimise inefficiencies, oversight, theft, and ultimately, unnecessary costs associated with your operations.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from skyledge_sdk.models.range import Range
from typing import Optional, Set
from typing_extensions import Self

class ControlRoomTaskSearchRequest(BaseModel):
    """
    ControlRoomTaskSearchRequest
    """ # noqa: E501
    created_at: Optional[Range] = Field(default=None, alias="createdAt")
    due_at: Optional[Range] = Field(default=None, alias="dueAt")
    task_ids: Optional[List[StrictStr]] = Field(default=None, alias="taskIds")
    task_type_ids: Optional[List[StrictStr]] = Field(default=None, alias="taskTypeIds")
    event_ids: Optional[List[StrictStr]] = Field(default=None, alias="eventIds")
    event_type_ids: Optional[List[StrictStr]] = Field(default=None, alias="eventTypeIds")
    asset_ids: Optional[List[StrictStr]] = Field(default=None, alias="assetIds")
    asset_type_ids: Optional[List[StrictStr]] = Field(default=None, alias="assetTypeIds")
    asset_identifiers: Optional[List[StrictStr]] = Field(default=None, alias="assetIdentifiers")
    task_attributes: Optional[Dict[str, Dict[str, Any]]] = Field(default=None, alias="taskAttributes")
    status: Optional[List[StrictStr]] = None
    deleted: Optional[StrictBool] = None
    __properties: ClassVar[List[str]] = ["createdAt", "dueAt", "taskIds", "taskTypeIds", "eventIds", "eventTypeIds", "assetIds", "assetTypeIds", "assetIdentifiers", "taskAttributes", "status", "deleted"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ControlRoomTaskSearchRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of created_at
        if self.created_at:
            _dict['createdAt'] = self.created_at.to_dict()
        # override the default output from pydantic by calling `to_dict()` of due_at
        if self.due_at:
            _dict['dueAt'] = self.due_at.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ControlRoomTaskSearchRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "createdAt": Range.from_dict(obj["createdAt"]) if obj.get("createdAt") is not None else None,
            "dueAt": Range.from_dict(obj["dueAt"]) if obj.get("dueAt") is not None else None,
            "taskIds": obj.get("taskIds"),
            "taskTypeIds": obj.get("taskTypeIds"),
            "eventIds": obj.get("eventIds"),
            "eventTypeIds": obj.get("eventTypeIds"),
            "assetIds": obj.get("assetIds"),
            "assetTypeIds": obj.get("assetTypeIds"),
            "assetIdentifiers": obj.get("assetIdentifiers"),
            "taskAttributes": obj.get("taskAttributes"),
            "status": obj.get("status"),
            "deleted": obj.get("deleted")
        })
        return _obj


