# coding: utf-8

"""
    Skyledge API

    Sky Ledge is an operational insights platform that gives you the visibility and control you need to minimise inefficiencies, oversight, theft, and ultimately, unnecessary costs associated with your operations.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from skyledge_sdk.models.geometry_collection_all_of_geometries import GeometryCollectionAllOfGeometries
from typing import Optional, Set
from typing_extensions import Self

class CycleRequest(BaseModel):
    """
    CycleRequest
    """ # noqa: E501
    asset_id: StrictStr = Field(alias="assetId")
    name: Optional[StrictStr] = None
    start_location: GeometryCollectionAllOfGeometries = Field(alias="startLocation")
    end_location: GeometryCollectionAllOfGeometries = Field(alias="endLocation")
    start_time: Optional[datetime] = Field(default=None, alias="startTime")
    end_time: Optional[datetime] = Field(default=None, alias="endTime")
    description: Optional[StrictStr] = None
    attributes: Dict[str, Any]
    __properties: ClassVar[List[str]] = ["assetId", "name", "startLocation", "endLocation", "startTime", "endTime", "description", "attributes"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CycleRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of start_location
        if self.start_location:
            _dict['startLocation'] = self.start_location.to_dict()
        # override the default output from pydantic by calling `to_dict()` of end_location
        if self.end_location:
            _dict['endLocation'] = self.end_location.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CycleRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "assetId": obj.get("assetId"),
            "name": obj.get("name"),
            "startLocation": GeometryCollectionAllOfGeometries.from_dict(obj["startLocation"]) if obj.get("startLocation") is not None else None,
            "endLocation": GeometryCollectionAllOfGeometries.from_dict(obj["endLocation"]) if obj.get("endLocation") is not None else None,
            "startTime": obj.get("startTime"),
            "endTime": obj.get("endTime"),
            "description": obj.get("description"),
            "attributes": obj.get("attributes")
        })
        return _obj


