# coding: utf-8

"""
    Skyledge API

    Sky Ledge is an operational insights platform that gives you the visibility and control you need to minimise inefficiencies, oversight, theft, and ultimately, unnecessary costs associated with your operations.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from skyledge_sdk.models.entity_response import EntityResponse
from skyledge_sdk.models.geometry_collection_all_of_geometries import GeometryCollectionAllOfGeometries
from typing import Optional, Set
from typing_extensions import Self

class CycleResponse(BaseModel):
    """
    CycleResponse
    """ # noqa: E501
    id: StrictStr
    cycle_type_id: StrictStr = Field(alias="cycleTypeId")
    created_at: StrictStr = Field(alias="createdAt")
    start_time: StrictStr = Field(alias="startTime")
    end_time: StrictStr = Field(alias="endTime")
    last_modified_at: StrictStr = Field(alias="lastModifiedAt")
    name: StrictStr
    description: StrictStr
    start_location: Optional[GeometryCollectionAllOfGeometries] = Field(default=None, alias="startLocation")
    end_location: Optional[GeometryCollectionAllOfGeometries] = Field(default=None, alias="endLocation")
    is_active: StrictBool = Field(alias="isActive")
    entities: List[EntityResponse]
    attributes: Optional[Dict[str, Any]] = None
    active: Optional[StrictBool] = None
    __properties: ClassVar[List[str]] = ["id", "cycleTypeId", "createdAt", "startTime", "endTime", "lastModifiedAt", "name", "description", "startLocation", "endLocation", "isActive", "entities", "attributes", "active"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CycleResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of start_location
        if self.start_location:
            _dict['startLocation'] = self.start_location.to_dict()
        # override the default output from pydantic by calling `to_dict()` of end_location
        if self.end_location:
            _dict['endLocation'] = self.end_location.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in entities (list)
        _items = []
        if self.entities:
            for _item_entities in self.entities:
                if _item_entities:
                    _items.append(_item_entities.to_dict())
            _dict['entities'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CycleResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "cycleTypeId": obj.get("cycleTypeId"),
            "createdAt": obj.get("createdAt"),
            "startTime": obj.get("startTime"),
            "endTime": obj.get("endTime"),
            "lastModifiedAt": obj.get("lastModifiedAt"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "startLocation": GeometryCollectionAllOfGeometries.from_dict(obj["startLocation"]) if obj.get("startLocation") is not None else None,
            "endLocation": GeometryCollectionAllOfGeometries.from_dict(obj["endLocation"]) if obj.get("endLocation") is not None else None,
            "isActive": obj.get("isActive"),
            "entities": [EntityResponse.from_dict(_item) for _item in obj["entities"]] if obj.get("entities") is not None else None,
            "attributes": obj.get("attributes"),
            "active": obj.get("active")
        })
        return _obj


