# coding: utf-8

"""
    Skyledge API

    Sky Ledge is an operational insights platform that gives you the visibility and control you need to minimise inefficiencies, oversight, theft, and ultimately, unnecessary costs associated with your operations.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CycleSearchRequest(BaseModel):
    """
    CycleSearchRequest
    """ # noqa: E501
    asset_ids: List[StrictStr] = Field(alias="assetIds")
    place_ids: Optional[List[StrictStr]] = Field(default=None, alias="placeIds")
    active: Optional[StrictBool] = None
    cycle_type_ids: Optional[List[StrictStr]] = Field(default=None, alias="cycleTypeIds")
    cycle_type_identifiers: Optional[List[StrictStr]] = Field(default=None, alias="cycleTypeIdentifiers")
    start_date: Optional[datetime] = Field(default=None, alias="startDate")
    end_date: Optional[datetime] = Field(default=None, alias="endDate")
    active_at: Optional[datetime] = Field(default=None, alias="activeAt")
    __properties: ClassVar[List[str]] = ["assetIds", "placeIds", "active", "cycleTypeIds", "cycleTypeIdentifiers", "startDate", "endDate", "activeAt"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CycleSearchRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CycleSearchRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "assetIds": obj.get("assetIds"),
            "placeIds": obj.get("placeIds"),
            "active": obj.get("active"),
            "cycleTypeIds": obj.get("cycleTypeIds"),
            "cycleTypeIdentifiers": obj.get("cycleTypeIdentifiers"),
            "startDate": obj.get("startDate"),
            "endDate": obj.get("endDate"),
            "activeAt": obj.get("activeAt")
        })
        return _obj


