# coding: utf-8

"""
    Skyledge API

    Sky Ledge is an operational insights platform that gives you the visibility and control you need to minimise inefficiencies, oversight, theft, and ultimately, unnecessary costs associated with your operations.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from skyledge_sdk.models.event_place import EventPlace
from typing import Optional, Set
from typing_extensions import Self

class EventRequest(BaseModel):
    """
    EventRequest
    """ # noqa: E501
    dynamic_attributes: Dict[str, Any] = Field(alias="dynamicAttributes")
    importance_level: Optional[StrictInt] = Field(default=None, alias="importanceLevel")
    location: Optional[Dict[str, Any]] = None
    external_urls: Dict[str, StrictStr] = Field(alias="externalUrls")
    asset_id: Optional[StrictStr] = Field(default=None, alias="assetId")
    asset_identifier: Optional[StrictStr] = Field(default=None, alias="assetIdentifier")
    places: List[EventPlace]
    qualifier: StrictStr
    timestamp: Optional[datetime] = None
    __properties: ClassVar[List[str]] = ["dynamicAttributes", "importanceLevel", "location", "externalUrls", "assetId", "assetIdentifier", "places", "qualifier", "timestamp"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EventRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in places (list)
        _items = []
        if self.places:
            for _item_places in self.places:
                if _item_places:
                    _items.append(_item_places.to_dict())
            _dict['places'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EventRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dynamicAttributes": obj.get("dynamicAttributes"),
            "importanceLevel": obj.get("importanceLevel"),
            "location": obj.get("location"),
            "externalUrls": obj.get("externalUrls"),
            "assetId": obj.get("assetId"),
            "assetIdentifier": obj.get("assetIdentifier"),
            "places": [EventPlace.from_dict(_item) for _item in obj["places"]] if obj.get("places") is not None else None,
            "qualifier": obj.get("qualifier"),
            "timestamp": obj.get("timestamp")
        })
        return _obj


