# coding: utf-8

"""
    Skyledge API

    Sky Ledge is an operational insights platform that gives you the visibility and control you need to minimise inefficiencies, oversight, theft, and ultimately, unnecessary costs associated with your operations.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class EventSearchRequest(BaseModel):
    """
    EventSearchRequest
    """ # noqa: E501
    start_date: Optional[datetime] = Field(default=None, alias="startDate")
    end_date: Optional[datetime] = Field(default=None, alias="endDate")
    before: Optional[datetime] = None
    after: Optional[datetime] = None
    event_ids: Optional[List[StrictStr]] = Field(default=None, alias="eventIds")
    asset_ids: Optional[List[StrictStr]] = Field(default=None, alias="assetIds")
    asset_identifiers: Optional[List[StrictStr]] = Field(default=None, alias="assetIdentifiers")
    place_ids: Optional[List[StrictStr]] = Field(default=None, alias="placeIds")
    place_type_ids: Optional[List[StrictStr]] = Field(default=None, alias="placeTypeIds")
    place_identifiers: Optional[List[StrictStr]] = Field(default=None, alias="placeIdentifiers")
    event_type_ids: Optional[List[StrictStr]] = Field(default=None, alias="eventTypeIds")
    importance_levels: Optional[List[StrictInt]] = Field(default=None, alias="importanceLevels")
    bounds: Optional[StrictStr] = None
    event_type_attributes: Optional[Dict[str, Dict[str, Any]]] = Field(default=None, alias="eventTypeAttributes")
    state: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["startDate", "endDate", "before", "after", "eventIds", "assetIds", "assetIdentifiers", "placeIds", "placeTypeIds", "placeIdentifiers", "eventTypeIds", "importanceLevels", "bounds", "eventTypeAttributes", "state"]

    @field_validator('state')
    def state_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['ACTIVE', 'COMPLETE', 'RESOLVED']):
            raise ValueError("must be one of enum values ('ACTIVE', 'COMPLETE', 'RESOLVED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EventSearchRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EventSearchRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "startDate": obj.get("startDate"),
            "endDate": obj.get("endDate"),
            "before": obj.get("before"),
            "after": obj.get("after"),
            "eventIds": obj.get("eventIds"),
            "assetIds": obj.get("assetIds"),
            "assetIdentifiers": obj.get("assetIdentifiers"),
            "placeIds": obj.get("placeIds"),
            "placeTypeIds": obj.get("placeTypeIds"),
            "placeIdentifiers": obj.get("placeIdentifiers"),
            "eventTypeIds": obj.get("eventTypeIds"),
            "importanceLevels": obj.get("importanceLevels"),
            "bounds": obj.get("bounds"),
            "eventTypeAttributes": obj.get("eventTypeAttributes"),
            "state": obj.get("state")
        })
        return _obj


