# coding: utf-8

"""
    Skyledge API

    Sky Ledge is an operational insights platform that gives you the visibility and control you need to minimise inefficiencies, oversight, theft, and ultimately, unnecessary costs associated with your operations.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from typing_extensions import Annotated
from skyledge_sdk.models.aggregation_parameter_request import AggregationParameterRequest
from skyledge_sdk.models.cycle_aggregation_parameter_request import CycleAggregationParameterRequest
from skyledge_sdk.models.date_grouping import DateGrouping
from typing import Optional, Set
from typing_extensions import Self

class ExecuteAssetsAggregationRequest(BaseModel):
    """
    ExecuteAssetsAggregationRequest
    """ # noqa: E501
    parameters: Annotated[List[AggregationParameterRequest], Field(min_length=1)]
    cycle_parameters: List[CycleAggregationParameterRequest] = Field(alias="cycleParameters")
    asset_ids: List[StrictStr] = Field(alias="assetIds")
    asset_identifiers: List[Any] = Field(alias="assetIdentifiers")
    date_grouping: DateGrouping = Field(alias="dateGrouping")
    __properties: ClassVar[List[str]] = ["parameters", "cycleParameters", "assetIds", "assetIdentifiers", "dateGrouping"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ExecuteAssetsAggregationRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in parameters (list)
        _items = []
        if self.parameters:
            for _item_parameters in self.parameters:
                if _item_parameters:
                    _items.append(_item_parameters.to_dict())
            _dict['parameters'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in cycle_parameters (list)
        _items = []
        if self.cycle_parameters:
            for _item_cycle_parameters in self.cycle_parameters:
                if _item_cycle_parameters:
                    _items.append(_item_cycle_parameters.to_dict())
            _dict['cycleParameters'] = _items
        # override the default output from pydantic by calling `to_dict()` of date_grouping
        if self.date_grouping:
            _dict['dateGrouping'] = self.date_grouping.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ExecuteAssetsAggregationRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "parameters": [AggregationParameterRequest.from_dict(_item) for _item in obj["parameters"]] if obj.get("parameters") is not None else None,
            "cycleParameters": [CycleAggregationParameterRequest.from_dict(_item) for _item in obj["cycleParameters"]] if obj.get("cycleParameters") is not None else None,
            "assetIds": obj.get("assetIds"),
            "assetIdentifiers": obj.get("assetIdentifiers"),
            "dateGrouping": DateGrouping.from_dict(obj["dateGrouping"]) if obj.get("dateGrouping") is not None else None
        })
        return _obj


