# coding: utf-8

"""
    Skyledge API

    Sky Ledge is an operational insights platform that gives you the visibility and control you need to minimise inefficiencies, oversight, theft, and ultimately, unnecessary costs associated with your operations.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from skyledge_sdk.models.crs import Crs
from skyledge_sdk.models.geo_json_object import GeoJsonObject
from typing import Optional, Set
from typing_extensions import Self

class Feature(GeoJsonObject):
    """
    Feature
    """ # noqa: E501
    properties: Optional[Dict[str, Any]] = None
    geometry: Optional[FeatureAllOfGeometry1] = None
    id: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["crs", "bbox", "type", "properties", "geometry", "id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Feature from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of crs
        if self.crs:
            _dict['crs'] = self.crs.to_dict()
        # override the default output from pydantic by calling `to_dict()` of geometry
        if self.geometry:
            _dict['geometry'] = self.geometry.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Feature from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "crs": Crs.from_dict(obj["crs"]) if obj.get("crs") is not None else None,
            "bbox": obj.get("bbox"),
            "type": obj.get("type"),
            "properties": obj.get("properties"),
            "geometry": FeatureAllOfGeometry1.from_dict(obj["geometry"]) if obj.get("geometry") is not None else None,
            "id": obj.get("id")
        })
        return _obj

from skyledge_sdk.models.feature_all_of_geometry1 import FeatureAllOfGeometry1
# TODO: Rewrite to not use raise_errors
Feature.model_rebuild(raise_errors=False)

