# coding: utf-8

"""
    Skyledge API

    Sky Ledge is an operational insights platform that gives you the visibility and control you need to minimise inefficiencies, oversight, theft, and ultimately, unnecessary costs associated with your operations.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from skyledge_sdk.models.execution import Execution
from skyledge_sdk.models.notification_rule_action import NotificationRuleAction
from skyledge_sdk.models.update_rule_type_request_options import UpdateRuleTypeRequestOptions
from typing import Optional, Set
from typing_extensions import Self

class RuleRequest(BaseModel):
    """
    RuleRequest
    """ # noqa: E501
    identifier: StrictStr
    trigger_on: Optional[StrictStr] = Field(default=None, alias="triggerOn")
    name: StrictStr
    description: StrictStr
    enabled: Optional[StrictBool] = None
    execution: Optional[Execution] = None
    owner_id: Optional[StrictStr] = Field(default=None, alias="ownerId")
    options: UpdateRuleTypeRequestOptions
    actions: List[NotificationRuleAction]
    __properties: ClassVar[List[str]] = ["identifier", "triggerOn", "name", "description", "enabled", "execution", "ownerId", "options", "actions"]

    @field_validator('trigger_on')
    def trigger_on_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['event.created', 'place.entered', 'place.exited', 'task.created']):
            raise ValueError("must be one of enum values ('event.created', 'place.entered', 'place.exited', 'task.created')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RuleRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of execution
        if self.execution:
            _dict['execution'] = self.execution.to_dict()
        # override the default output from pydantic by calling `to_dict()` of options
        if self.options:
            _dict['options'] = self.options.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in actions (list)
        _items = []
        if self.actions:
            for _item_actions in self.actions:
                if _item_actions:
                    _items.append(_item_actions.to_dict())
            _dict['actions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RuleRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "identifier": obj.get("identifier"),
            "triggerOn": obj.get("triggerOn"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "enabled": obj.get("enabled"),
            "execution": Execution.from_dict(obj["execution"]) if obj.get("execution") is not None else None,
            "ownerId": obj.get("ownerId"),
            "options": UpdateRuleTypeRequestOptions.from_dict(obj["options"]) if obj.get("options") is not None else None,
            "actions": [NotificationRuleAction.from_dict(_item) for _item in obj["actions"]] if obj.get("actions") is not None else None
        })
        return _obj


