# coding: utf-8

"""
    Skyledge API

    Sky Ledge is an operational insights platform that gives you the visibility and control you need to minimise inefficiencies, oversight, theft, and ultimately, unnecessary costs associated with your operations.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from skyledge_sdk.models.event_display import EventDisplay
from typing import Optional, Set
from typing_extensions import Self

class UpdateEventTypeRequest(BaseModel):
    """
    UpdateEventTypeRequest
    """ # noqa: E501
    name: StrictStr
    title: StrictStr
    description: StrictStr
    default_importance_level: StrictInt = Field(alias="defaultImportanceLevel")
    location_type: StrictStr = Field(alias="locationType")
    state: StrictStr
    category: Optional[StrictStr] = None
    event_display: Optional[EventDisplay] = Field(default=None, alias="eventDisplay")
    control_rooms: Optional[List[StrictStr]] = Field(default=None, alias="controlRooms")
    __properties: ClassVar[List[str]] = ["name", "title", "description", "defaultImportanceLevel", "locationType", "state", "category", "eventDisplay", "controlRooms"]

    @field_validator('category')
    def category_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['DISCRETE', 'ONGOING']):
            raise ValueError("must be one of enum values ('DISCRETE', 'ONGOING')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateEventTypeRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of event_display
        if self.event_display:
            _dict['eventDisplay'] = self.event_display.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateEventTypeRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "title": obj.get("title"),
            "description": obj.get("description"),
            "defaultImportanceLevel": obj.get("defaultImportanceLevel"),
            "locationType": obj.get("locationType"),
            "state": obj.get("state"),
            "category": obj.get("category"),
            "eventDisplay": EventDisplay.from_dict(obj["eventDisplay"]) if obj.get("eventDisplay") is not None else None,
            "controlRooms": obj.get("controlRooms")
        })
        return _obj


