# coding: utf-8

"""
    Skyledge API

    Sky Ledge is an operational insights platform that gives you the visibility and control you need to minimise inefficiencies, oversight, theft, and ultimately, unnecessary costs associated with your operations.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from skyledge_sdk.models.event_created_options import EventCreatedOptions
from skyledge_sdk.models.place_entered_exited_options import PlaceEnteredExitedOptions
from skyledge_sdk.models.task_created_options import TaskCreatedOptions
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

UPDATERULETYPEREQUESTOPTIONS_ONE_OF_SCHEMAS = ["EventCreatedOptions", "PlaceEnteredExitedOptions", "TaskCreatedOptions"]

class UpdateRuleTypeRequestOptions(BaseModel):
    """
    UpdateRuleTypeRequestOptions
    """
    # data type: EventCreatedOptions
    oneof_schema_1_validator: Optional[EventCreatedOptions] = None
    # data type: PlaceEnteredExitedOptions
    oneof_schema_2_validator: Optional[PlaceEnteredExitedOptions] = None
    # data type: TaskCreatedOptions
    oneof_schema_3_validator: Optional[TaskCreatedOptions] = None
    actual_instance: Optional[Union[EventCreatedOptions, PlaceEnteredExitedOptions, TaskCreatedOptions]] = None
    one_of_schemas: Set[str] = { "EventCreatedOptions", "PlaceEnteredExitedOptions", "TaskCreatedOptions" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = UpdateRuleTypeRequestOptions.model_construct()
        error_messages = []
        match = 0
        # validate data type: EventCreatedOptions
        if not isinstance(v, EventCreatedOptions):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EventCreatedOptions`")
        else:
            match += 1
        # validate data type: PlaceEnteredExitedOptions
        if not isinstance(v, PlaceEnteredExitedOptions):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PlaceEnteredExitedOptions`")
        else:
            match += 1
        # validate data type: TaskCreatedOptions
        if not isinstance(v, TaskCreatedOptions):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TaskCreatedOptions`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in UpdateRuleTypeRequestOptions with oneOf schemas: EventCreatedOptions, PlaceEnteredExitedOptions, TaskCreatedOptions. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in UpdateRuleTypeRequestOptions with oneOf schemas: EventCreatedOptions, PlaceEnteredExitedOptions, TaskCreatedOptions. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into EventCreatedOptions
        try:
            instance.actual_instance = EventCreatedOptions.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PlaceEnteredExitedOptions
        try:
            instance.actual_instance = PlaceEnteredExitedOptions.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into TaskCreatedOptions
        try:
            instance.actual_instance = TaskCreatedOptions.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into UpdateRuleTypeRequestOptions with oneOf schemas: EventCreatedOptions, PlaceEnteredExitedOptions, TaskCreatedOptions. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into UpdateRuleTypeRequestOptions with oneOf schemas: EventCreatedOptions, PlaceEnteredExitedOptions, TaskCreatedOptions. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], EventCreatedOptions, PlaceEnteredExitedOptions, TaskCreatedOptions]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


